from typing import Any

import dream3d.simpl

class DetectEllipsoids(dream3d.simpl.AbstractFilter):
    CenterCoordinatesArrayName: str
    DetectedEllipsoidsFeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    EllipseFeatureAttributeMatrixPath: dream3d.simpl.DataArrayPath
    FeatureAttributeMatrixPath: dream3d.simpl.DataArrayPath
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    HoughTransformThreshold: float
    ImageScaleBarLength: int
    MajorAxisLengthArrayName: str
    MaxFiberAxisLength: int
    MinAspectRatio: float
    MinFiberAxisLength: int
    MinorAxisLengthArrayName: str
    RotationalAnglesArrayName: str
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class ErodeDilateBadData(dream3d.simpl.AbstractFilter):
    Direction: int
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    NumIterations: int
    XDirOn: bool
    YDirOn: bool
    ZDirOn: bool
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class ErodeDilateCoordinationNumber(dream3d.simpl.AbstractFilter):
    CoordinationNumber: int
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    Loop: bool
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class ErodeDilateMask(dream3d.simpl.AbstractFilter):
    MaskArrayPath: dream3d.simpl.DataArrayPath
    NumIterations: int
    XDirOn: bool
    YDirOn: bool
    ZDirOn: bool
    int: int
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class FillBadData(dream3d.simpl.AbstractFilter):
    CellPhasesArrayPath: dream3d.simpl.DataArrayPath
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    MinAllowedDefectSize: int
    StoreAsNewPhase: bool
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class FindProjectedImageStatistics(dream3d.simpl.AbstractFilter):
    ProjectedImageAvgArrayName: str
    ProjectedImageMaxArrayName: str
    ProjectedImageMinArrayName: str
    ProjectedImageStdArrayName: str
    ProjectedImageVarArrayName: str
    SelectedArrayPath: dream3d.simpl.DataArrayPath
    int: int
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class FindRelativeMotionBetweenSlices(dream3d.simpl.AbstractFilter):
    MotionDirectionArrayName: str
    PSize1: int
    PSize2: int
    SSize1: int
    SSize2: int
    SelectedArrayPath: dream3d.simpl.DataArrayPath
    SliceStep: int
    int: int
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class IdentifySample(dream3d.simpl.AbstractFilter):
    FillHoles: bool
    GoodVoxelsArrayPath: dream3d.simpl.DataArrayPath
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class MinNeighbors(dream3d.simpl.AbstractFilter):
    ApplyToSinglePhase: bool
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    FeaturePhasesArrayPath: dream3d.simpl.DataArrayPath
    MinNumNeighbors: int
    NumNeighborsArrayPath: dream3d.simpl.DataArrayPath
    PhaseNumber: int
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class MinSize(dream3d.simpl.AbstractFilter):
    ApplyToSinglePhase: bool
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    FeaturePhasesArrayPath: dream3d.simpl.DataArrayPath
    MinAllowedFeatureSize: int
    NumCellsArrayPath: dream3d.simpl.DataArrayPath
    PhaseNumber: int
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class RemoveFlaggedFeatures(dream3d.simpl.AbstractFilter):
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    FillRemovedFeatures: bool
    FlaggedFeaturesArrayPath: dream3d.simpl.DataArrayPath
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...
